# -*- coding: utf-8 -*-
# N guage control panel by ik-gadgets
# Network interface = Serial com port

import sys
import re
import os
import time
from multiprocessing import Process,Queue
from dummy_hard_ikcp_gui2 import ikcp_gui

TxRx_interval = 0.1 # minimum period of Tx/Rx loop (sec)

def main():
    rx_list = []
    tx_list = []
    print()
    serial_port_name = None
    panel_file_list = []
    auto_prg_file_list = []
    com_print_flag = 0
    beep_flag = 0

    if len(sys.argv) >= 2:
        for file_name in sys.argv[1:]:
            if re.search(r'\.txt$',file_name):
                if os.path.exists(file_name):
                    panel_file_list.append(file_name)
                else:
                    print("### ERROR ### file",file_name,"not found")
                    print()
                    sys.exit()
            elif re.search(r'\.py$',file_name):
                if os.path.exists(file_name):
                    auto_prg_file_list.append(file_name)
                else:
                    print("### ERROR ### file",file_name,"not found")
                    print()
                    sys.exit()
            elif re.search(r'^\-print$',file_name): # print auto_read/write to com window
                com_print_flag = 3
            elif re.search(r'^\-print_r',file_name): # print auto_read/write to com window
                com_print_flag = 1
            elif re.search(r'^\-print_w',file_name): # print auto_read/write to com window
                com_print_flag = 2
            elif re.search(r'^\-beep$',file_name): # beep on auto_read/write
                beep_flag = 3
            elif re.search(r'^\-beep_r',file_name): # beep on auto_read/write
                beep_flag = 1
            elif re.search(r'^\-beep_w',file_name): # beep on auto_read/write
                beep_flag = 2
            else:
                print("### ERROR ###",file_name,"? argument must be *.txt or *.py")
                print()
                sys.exit()

    qtx = Queue()
    qrx = Queue()

    process = Process(target=ikcp_gui,args=(qtx,qrx,panel_file_list,auto_prg_file_list,com_print_flag,beep_flag))
    process.start()

    while True:
        if qtx.qsize() != 0:
            data = qtx.get()
            if data == [255,255]: # dicsonnect flag from GUI
                break
            else:
                if data == 255: # find END code
                    time.sleep(0.1)
                qrx.put(data)


if __name__ == '__main__':
    main()
