# -*- coding: utf-8 -*-
# N guage control panel graphic user interface by ik-gadgets
# コマンド等については下記の def print_help(): 以下を参照

import sys
import os
import re
import pygame
import time
from pygame.locals import *
import winsound

txrx_interval = 0.1 # minimum period of Tx/Rx loop (sec)

##### GUI #####
def ikcp_gui(qtx,qrx,panel_file_list,auto_prg_file_list,com_print_flag,beep_flag):
    global BACK_PANEL
    global window_h
    global window_w
    global grid_unit
    global string1
    global string2
    global key
    global sysfont
    global Nofont
    global controlfont
    global number_ON
    global option_ON
    global grid_on
    global file_name
    global facilities
    global text_list
    global lines
    global eventflag
    global tx_trigger_flag
    global auto_init_flag

    auto_init_flag = 1

    #### for automatic train control programing by exec auto_prg.txt ####
    No2objid = {}
    auto_save = {}
    auto_time_save = {}
    #### end ####

    time_cnt = 0
    sel_pos = [0,0]
    rx_list = []
    tx_list = []
    args = sys.argv
    print()
    tx_trigger_flag = 0
    rx_progress_flag = 0
    eventflag = 1
    pygame.init()

    #for x in pygame.font.get_fonts():
    #  print(x)
    #sys.exit()

    number_ON = 1
    option_ON = 1

    file_name = ""
    string1 = ""
    string2 = ""
    window_h = 500
    window_w = 1000
    grid_unit = 13
    grid_on = 0
    sysfont = pygame.font.SysFont("yumincho", 16)
    Nofont = pygame.font.SysFont("msgothic", 26)
    controlfont = pygame.font.SysFont("msgothic", 40)
    optionfont = pygame.font.SysFont("msgothic", 13,bold=True)

    #sysfont = pygame.font.SysFont(None, 26)
    #Nofont = pygame.font.SysFont(None, 36)
    #controlfont = pygame.font.SysFont(None, 58)
    #optionfont = pygame.font.SysFont(None, 22)

    FPSCLOCK = pygame.time.Clock()
    FPSCLOCK.tick(30) # flame rate

    colorlist = [(0,0,0),(128,0,0),(255,0,0),(255,165,0),(255,255,0),
                 (0,128,0),(0,0,255),(128,0,128),(128,128,128),(255,255,255)]
                 # 黒、茶、赤、橙、黄、緑、青、紫、灰、白

    facilities = [] # [No,type,pos,...],[...
    text_list = []
    lines = []

    command_key_list = (
        K_w,
        K_n,
        K_o,
        K_g,
        K_r,
        K_h
       )

    #select_rect = pygame.Rect(0,0,1,1) # <-- select_rect.top = 0 の場合、選択なし。

    command_string_list =(
        "Write Data to ",
        "ID number ON/OFF",
        "option number ON/OFF",
        "Grid ON/OFF",
        "Read File",
        "Print Help to com window"
       )

    number_list = []

    #### SNTC2 loop net Tx/Rx commands and return value ####
    END =      0b11111111 # TxRx end mark
    READ =     0b11111110 # common read

    PMD_READ = 0b00000000 # Rx 2LSB:switch+direction
    PMD_W =    0b00000100 # Rx LSB:direction
    PMD_F =    0b00000110 # Rx LSB:direction

    SW_READ =  0b01110000 # Rx 2LSB:switch+direction
    SW_W =     0b01110100 # Rx LSB:direction

    SPD_READ = 0b00001000 # Rx 2LSB:switch+direction
    SPD_W =    0b00001100 # Rx LSB:direction
    SPD_F =    0b00001110 # Rx LSB:direction

    SIG3_READ    = 0b00010000 # Rx 2LSB:signal color
    SIG3_W       = 0b00010100 # Rx 2LSB:signal color
    SIG3_SENS_EN = 0b00011000 # Rx LSB:sensor enable
    SIG3_RTR     = 0b00011010 # Rx:R timer (0 to 0xFE)
    SIG3_RTY     = 0b00011011 # Rx:Y timer (0 to 0xFE)
    SIG3_RTG     = 0b00011100 # Rx:G timer (0 to 0xFE)
    SIG3_WTR     = 0b00100000 # 2 byte: Tx command + R timer
    SIG3_WTY     = 0b00100001 # 2 byte: Tx command + Y timer
    SIG3_WTG     = 0b00100010 # 2 byte: Tx command + G timer

    SENS_READ    = 0b00100100 # Rx LSB: sens value

    SIG6_1_SENS_EN = 0b00100110 # LSB: sensor control enable
    SIG6_2_SENS_EN = 0b00101000 # LSB: sensor control enable
    SIG6_READ    = 0b00110000 # lower 4bit: signal color
    SIG6_W       = 0b01000000 # lower 4bit: signal color
    SIG6_REVP    = 0b01010000 # lower 3bit EVP: 3bitは順に基板(回路図)上のPICマイコン19pin(XNO_POINT)、7pin(POINT_INV)、6pin(POINT)の読み出し値
    SIG6_1_RTR   = 0b01011000 # Rx:R1 timer (0 to 0xFE)
    SIG6_1_RTY   = 0b01011001 # Rx:Y1 timer (0 to 0xFE)
    SIG6_1_RTG   = 0b01011010 # Rx:G1 timer (0 to 0xFE)
    SIG6_2_RTR   = 0b01011011 # Rx:R2 timer (0 to 0xFE)
    SIG6_2_RTY   = 0b01011100 # Rx:Y2 timer (0 to 0xFE)
    SIG6_2_RTG   = 0b01011101 # Rx:G2 timer (0 to 0xFE)
    SIG6_RWAIT   = 0b01011110 # Rx:point switch->SIG6 delay
    SIG6_1_WTR   = 0b01100000 # 2 byte: Tx command + R1 timer
    SIG6_1_WTY   = 0b01100001 # 2 byte: Tx command + Y1 timer
    SIG6_1_WTG   = 0b01100010 # 2 byte: Tx command + G1 timer
    SIG6_2_WTR   = 0b01100011 # 2 byte: Tx command + R2 timer
    SIG6_2_WTY   = 0b01100100 # 2 byte: Tx command + Y2 timer
    SIG6_2_WTG   = 0b01100101 # 2 byte: Tx command + G2 timer
    SIG6_WWAIT   = 0b01100110 # 2 byte: Tx command + point switch->SIG6 delay

    PWR_READ     = 0b01101000 #
    PWR_A        = 0b01101001 # Rx: Current value
    PWR_PWM      = 0b01101010 # 2 byte: Tx command + PWM value
    PWR_ACC      = 0b01101011 # 2 byte: Tx command + ACC value
    PWR_ZOF      = 0b01101100 # 2 byte: Tx command + PWM zero offset value
    PWR_WOB      = 0b01101101 # 2 byte: Tx command + wobbling value(2bit:time width,6bot: strength)

    def index2color(i):
        if 0 <= i < len(colorlist):
            return colorlist[i]
        else:
            B = i%1000
            if B > 255: B = 255
            G = int(i/1000)%1000
            if G > 255: G = 255
            R = int(i/1000000)
            if R > 255: R = 255
            return (R,G,B)

    def add_No(i,j):
        if i > 0:
            number_list.append(i)
            No2objid[i] = j

    def print_TxRx_ERROR(err_no,id,Txlist,Rxlist):
        print("### TxRx ERROR {} ### ID number={}".format(err_no,id))

        print("     Tx data =",end="")
        for i in range(len(Txlist)):
            print(" {0:08b}".format(Txlist[i]),end="")
        print("")

        if len(Rxlist) > 0:
            print("     Rx data =",end="")
            for i in range(len(Rxlist)):
                print(" {0:08b}".format(Rxlist[i]),end="")
            print("")

    class Line:
        def __init__(self,x1,y1,x2,y2,color_index=0,select_flag=0):
            self.x1 = x1
            self.y1 = y1
            self.x2 = x2
            self.y2 = y2
            self.color_index = color_index
            self.select_flag = select_flag

    class Text:
        def __init__(self,x,y,font_name,font_size,bold,color_index,text,select_flag=0):
            self.x = x
            self.y = y
            self.font_name = font_name
            self.font_size = font_size
            self.bold = bold
            self.color_index = color_index
            self.color = index2color(color_index)
            self.text = text
            self.select_flag = select_flag
            self.font = pygame.font.SysFont(font_name,font_size,bold)
            (self.w,self.h) = self.font.size(text)
            self.bmp = self.font.render(self.text,True,self.color)

        def flip(self):
            None

        def rotate(self):
            None

        def draw(self):
            BACK_PANEL.blit(self.bmp,(self.x,self.y))

        def string(self):
            tempstr = self.__class__.__name__ \
                + " " + str(self.x) \
                + " " + str(self.y) \
                + " yumincho" \
                + " " + str(int(self.font_size)) \
                + " " + str(self.bold) \
                + " " + str(self.color_index) \
                + ' "'+ self.text \
                + '"\n'
            return tempstr

    class Base:
        def __init__(self,number,x,y,w=26,h=26,color_index=0,flip_flag=0,rotate_angle=0,select_flag=0):
            self.number = number
            self.x = x
            self.y = y
            self.w = w
            self.h = h
            self.color_index = color_index
            self.color = index2color(color_index)
            self.flip_flag = flip_flag
            self.rotate_angle = rotate_angle
            self.select_flag = select_flag

        def select(self,pos):
            if self.x <= pos[0] <= self.x+self.w and self.y <= pos[1] <= self.y+self.h:
                self.select_flag = 1 # select flag on
                return 1
            else:
                self.select_flag = 0 # select flag off
                return 0

        def mouse(self,button,pos):
            None # dummy function

        def flip(self):
            None

        def rotate(self):
            None

        def draw(self): # draw rectangle if selected
            if (self.select_flag):
                sx = self.x - 2
                sy = self.y - 2
                if self.rotate_angle == 0 or self.rotate_angle == 180:
                    sw = self.w + 2
                    sh = self.h + 2
                else:
                    sh = self.w + 2
                    sw = self.h + 2
                if self.color_index == 2 or self.color_index == 3: # color = red or orange
                    pygame.draw.rect(BACK_PANEL,colorlist[0],(sx,sy,sw,sh),2) # select line = black
                else:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(sx,sy,sw,sh),2) # select line = red

    class Tile(Base):
        def __init__(self,number,x,y,flip_flag=0,rotate_angle=0,w=26,h=26,color_index=0,select_flag=0,k=0,image_file=None):
            super().__init__(number,x,y,w,h,color_index,flip_flag,rotate_angle)
            self.image_file = image_file
            if image_file:
                if os.path.exists(image_file):
                    self.image = pygame.image.load(image_file)
                    self.w = self.image.get_width()
                    self.h = self.image.get_height()
                    self.k = k
                    if k > 0:
                        self.h = int(self.h * k / self.w)
                        self.w = k
                        self.image = pygame.transform.scale(self.image,(self.w,self.h))
                else:
                    print("### ERROR ### ",image_file," not found")
                    pygame.quit()
                    sys.exit()

        def select(self,pos):
            None

        def draw(self):
            if self.image_file:
                if self.flip_flag == 0 and self.rotate_angle == 0:
                        BACK_PANEL.blit(self.image,(self.x,self.y))
                else:
                    im = self.image
                    if self.flip_flag:
                        im = pygame.transform.flip(im,True,False)
                    if self.rotate_angle:
                        im = pygame.transform.rotate(im,self.rotate_angle)
                        self.w = im.get_width()
                        self.h = im.get_height()
                    BACK_PANEL.blit(im,(self.x,self.y))
            else:
                pygame.draw.rect(BACK_PANEL,self.color,(self.x,self.y,self.w,self.h),0)

    #        if self.select_flag:
    #            bmp = Nofont.render(str(self.number), True, colorlist[0])
    #            BACK_PANEL.blit(bmp, (self.x,self.y-24))
            super().draw() # draw rectangle if selected

        def flip(self):
            if self.image_file:
                self.flip_flag ^= 1
            else:
                (self.w,self.h) = (self.h,self.w)

        def rotate(self):
            if self.image_file:
                self.rotate_angle += 90
                if self.rotate_angle >= 360:
                    self.rotate_angle = 0
            else:
                (self.w,self.h) = (self.h,self.w)

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y))
            if self.image_file:
                tempstr += " " + str(int(self.flip_flag)) \
                    + " " + str(int(self.rotate_angle)) \
                    + " " + str(int(self.k)) \
                    + " " + self.image_file \
                    + "\n"
            else:
                tempstr += " " + str(int(self.w)) \
                    + " " + str(int(self.h)) \
                    + " " + str(int(self.color_index)) \
                    + "\n"
            return tempstr

    class Point(Base):
        def __init__(self,number,x,y,w=26*2,h=26*2,flip_flag=0,rotate_angle=0,select_flag=0):
            super().__init__(number,x,y,w,h)
            self.flip_flag = flip_flag
            self.rotate_angle = rotate_angle
            self.switch_input = 0
            self.tx_flip = self.flip_flag&1
            if self.flip_flag&2:
                self.tx_flip ^= 1
            self.tx_fifo = [PMD_F + self.tx_flip]

        def tx(self,tx_list):
            if not self.tx_fifo:
                tx_list.append(READ)
            else:
                tx_list.append(self.tx_fifo[0])

        def rx(self,rx_list):
            if len(self.tx_fifo):
               t = self.tx_fifo[0]
            else:
               t = READ
            if len(rx_list) == 1:
                print_TxRx_ERROR(1,self.number,[t],[rx_list[0]])
                rx_list.pop()
                return
            elif len(rx_list) == 0:
                print_TxRx_ERROR(2,self.number,[t],[])
                return

            if rx_list[0]&0xFC == PMD_READ:
                self.switch_input = (rx_list[0] & 2)>>1
                dir = rx_list[0] & 1
                exor = (self.flip_flag & 2)>>1
                dir ^= exor
                self.flip_flag &= 0xFE
                self.flip_flag += dir
            elif rx_list[0]&0xFE == PMD_W:
                None
            elif rx_list[0]&0xFE == PMD_F:
                None
            else:
                print_TxRx_ERROR(3,self.number,[t],[rx_list[0]])
            if self.tx_fifo:self.tx_fifo.pop(0)
            rx_list.pop(0)

        def mouse(self,button,pos):
            if self.select_flag and button == 1:
                self.tx_flip = self.flip_flag&1
                if self.flip_flag&2 == 0:
                    self.tx_flip ^= 1
                self.tx_fifo.append(PMD_F + self.tx_flip)

        def get(self):
            if self.flip_flag & 2:
                return 1 ^ self.tx_flip
            else:
                return self.tx_flip

        def set(self,d):
            d &= 0x01
            if self.flip_flag & 2:
                d ^= 1
            if self.tx_flip != d:
                self.tx_flip = d
                self.tx_fifo.append(PMD_F + self.tx_flip)

        def draw(self):
            draw_point(str(self.number),self.x,self.y,self.w,self.h,self.flip_flag,self.rotate_angle,self.__class__.__name__,self.tx_flip)
            super().draw() # draw rectangle if selected

        def flip(self):
            if self.flip_flag >= 3:
                self.flip_flag = 0
            else:
                self.flip_flag += 1

        def rotate(self):
            None

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y)) \
                + " " + str(int(self.flip_flag)) \
                + " " + str(int(self.rotate_angle)) \
                + "\n"
            return tempstr

    class Switch(Point):
        def __init__(self,number,x,y,w=26,h=26,flip_flag=0,rotate_angle=0,select_flag=0):
            super().__init__(number,x,y,w,h)
            self.flip_flag = flip_flag
            self.rotate_angle = rotate_angle
            self.switch_input = 0
            self.tx_flip = self.flip_flag&1
            if self.flip_flag&2:
                self.tx_flip ^= 1
            self.tx_fifo = [SW_W + self.tx_flip]

#        def tx(self,tx_list):
#            if not self.tx_fifo:
#                tx_list.append(READ)
#            else:
#                tx_list.append(self.tx_fifo[0])

        def rx(self,rx_list):
            if len(self.tx_fifo):
                t = self.tx_fifo[0]
            else:
                t = READ
            if len(rx_list) == 1:
                print_TxRx_ERROR(1,self.number,[t],[rx_list[0]])
                rx_list.pop()
                return
            elif len(rx_list) == 0:
                print_TxRx_ERROR(2,self.number,[t],[])
                return

            if rx_list[0]&0xFC == SW_READ:
                self.switch_input = (rx_list[0] & 2)>>1
                dir = rx_list[0] & 1
                exor = (self.flip_flag & 2)>>1
                dir ^= exor
                self.flip_flag &= 0xFE
                self.flip_flag += dir
            elif rx_list[0]&0xFE == SW_W:
                None
            else:
                print_TxRx_ERROR(3,self.number,[t],[rx_list[0]])
            if self.tx_fifo:self.tx_fifo.pop(0)
            rx_list.pop(0)

        def mouse(self,button,pos):
            if self.select_flag and button == 1:
                self.tx_flip = self.flip_flag&1
                if self.flip_flag&2 == 0:
                    self.tx_flip ^= 1
                self.tx_fifo.append(SW_W + self.tx_flip)

        def set(self,d):
            d &= 0x01
            if self.flip_flag & 2:
                d ^= 1
            if self.tx_flip != d:
                self.tx_flip = d
                self.tx_fifo.append(SW_W + self.tx_flip)

#        def draw(self):
#            draw_point(str(self.number),self.x,self.y,self.w,self.h,self.flip_flag,self.rotate_angle,self.__class__.__name__,self.tx_flip)
#            super().draw() # draw rectangle if selected

#        def flip(self):
#            if self.flip_flag >= 3:
#                self.flip_flag = 0
#            else:
#                self.flip_flag += 1

#        def rotate(self):
#            None

#        def string(self):
#            tempstr = "{:4}".format(self.number) \
#                + " " + self.__class__.__name__ \
#                + " " + str(int(self.x)) \
#                + " " + str(int(self.y)) \
#                + " " + str(int(self.flip_flag)) \
#                + " " + str(int(self.rotate_angle)) \
#                + "\n"
#            return tempstr

    class Point_slow(Point):
        def __init__(self,number,x,y,w=26*2,h=26*2,flip_flag=0,rotate_angle=0,select_flag=0):
            super().__init__(number,x,y,w,h,flip_flag,rotate_angle)
            self.tx_fifo = [SPD_F + self.tx_flip]

        def rx(self,rx_list):
            if len(self.tx_fifo):
               t = self.tx_fifo[0]
            else:
               t = READ
            if len(rx_list) == 1:
                print_TxRx_ERROR(4,self.number,[t],[rx_list[0]])
                return []
            elif len(rx_list) == 0:
                print_TxRx_ERROR(5,self.number,[t],[])
                return []
            if rx_list[0]&0xFC == SPD_READ:
                self.switch_input = (rx_list[0] & 2)>>1
                dir = rx_list[0] & 1
                exor = (self.flip_flag & 2)>>1
                dir ^= exor
                self.flip_flag &= 0xFE
                self.flip_flag += dir
            elif rx_list[0]&0xFE == SPD_F:
                None
            elif rx_list[0]&0xFE == SPD_W:
                None
            else:
                print_TxRx_ERROR(6,self.number,[t],[rx_list[0]])
            if self.tx_fifo:
                self.tx_fifo.pop(0)
            return rx_list.pop(0)

        def mouse(self,button,pos):
            if self.select_flag and button == 1:
                self.tx_flip = self.flip_flag&1
                if self.flip_flag&2 == 0:
                    self.tx_flip ^= 1
                self.tx_fifo.append(SPD_F + self.tx_flip)

        def set(self,d):
            d &= 0x01
            if self.flip_flag & 2:
                d ^= 1
            if self.tx_flip != d:
                self.tx_flip = d
                self.tx_fifo.append(SPD_F + self.tx_flip)

    def updown(val,max,but,step=1,min=0):
        if but == 1 or but == 4:
            val += step
            if val > max: val = max
        elif but == 3 or but == 5:
            if val >= min+step :val -= step
        return val

    class Controller(Base):
        def __init__(self,number,x,y,w=26*3,h=26*2,color_index=0,\
                     flip_flag=0,drive=0,acc=20,offset=0,wob_t=10,wob_p=0,current=0,select_flag=0): # wob_t=10 or 20 or 30 or 40
            super().__init__(number,x,y,w,h,color_index)
            self.flip_flag = flip_flag
            self.drive = drive
            self.acc = acc
            self.offset = offset
            self.wob_t = wob_t
            self.wob_p = wob_p
            if self.wob_t > 40:
                self.wob_t = 40
            elif self.wob_t < 10:
                self.wob_t = 10
            self.current = current
            dir_acc = acc & 0x7F
            dir_acc += flip_flag<<7
            wob = self.wob_p & 0x3F
            if self.wob_t >= 40:
                if wob == 0xFF:
                    wob = 0xFE
                wob += 0xC0
            elif self.wob_t >=30:
                wob += 0x80
            elif self.wob_t >=20:
                wob += 0x40
            self.tx_fifo = [[PWR_A],[PWR_PWM,drive],[PWR_ACC,dir_acc],[PWR_ZOF,offset],[PWR_WOB,wob]]
            self.com_loop_ptr = 0

        def tx(self,tx_list):
            if not self.tx_fifo:
                tx_list.append(PWR_A)
            else:
                com_word = self.tx_fifo[0]
                for com_byte in com_word:
                    tx_list.append(com_byte)

        def rx(self,rx_list):
            if self.tx_fifo:
                t = self.tx_fifo[0][0]
            else:
                t = PWR_A
            if len(rx_list) == 1:
                print_TxRx_ERROR(7,self.number,[t],[rx_list[0]])
                rx_list.pop()
                return
            elif len(rx_list) == 0:
                print_TxRx_ERROR(8,self.number,[t],[])
                return

            pop_cnt = 1
            r = rx_list[0]

            if r == PWR_READ:
                pop_cnt = 1
            elif t == PWR_A:
                self.current = r;
                pop_cnt = 1
            elif t == PWR_PWM:
                if self.tx_fifo[0][1] == rx_list[1]:
                    pop_cnt = 2
                else:
                    print_TxRx_ERROR(9,self.number,[t],[rx_list[0],rx_list[1]])
            elif t == PWR_ACC:
                if self.tx_fifo[0][1] == rx_list[1]:
                    pop_cnt = 2
                else:
                    print_TxRx_ERROR(10,self.number,[t],[rx_list[0],rx_list[1]])
            elif t == PWR_ZOF:
                if self.tx_fifo[0][1] == rx_list[1]:
                    pop_cnt = 2
                else:
                    print_TxRx_ERROR(11,self.number,[t],[rx_list[0],rx_list[1]])
            elif t == PWR_WOB:
                if self.tx_fifo[0][1] == rx_list[1]:
                    pop_cnt = 2
                else:
                    print_TxRx_ERROR(12,self.number,[t],[rx_list[0],rx_list[1]])
            else:
                print_TxRx_ERROR(13,self.number,[t],[r])
            for i in range(pop_cnt):
                rx_list.pop(0)
            if self.tx_fifo:self.tx_fifo.pop(0)

        def select(self,pos):
            self.select_flag = 0
            if pos[1] < self.y:
                return
            if pos[1] <= self.y+self.h:
                if pos[0] < self.x-26:
                    return
                elif pos[0] < self.x:
                    self.select_flag = 6 # select left triangle
                elif pos[0] <= self.x+self.w:
                    self.select_flag = 1 # select main
                elif pos[0] < self.x+self.w+26:
                    self.select_flag = 7 # select right triangle
            elif pos[1] <= self.y+self.h+22:
                if self.x < pos[0] <= self.x+53:
                    self.select_flag = 2 # select Acc
                elif option_ON and pos[0] <= self.x+129:
                    self.select_flag = 3 # select Offset
            elif option_ON and pos[1] <= self.y+self.h+42:
                if pos[0] <= self.x+65:
                    self.select_flag = 4 # select Wob_t
                elif pos[0] <= self.x+123:
                    self.select_flag = 5 # select Wob_p

        def mouse(self,button,pos):
            if self.select_flag==1: # drive PWM
                temp = self.drive
                if button == 1 or button == 4:
                    if temp < 10: temp += 1
                    elif temp < 50: temp += 5
                    else: temp += 10
                    if temp + self.offset > 200:
                        temp = 200 - self.offset
                        temp = int(round(temp/10,0)*10)
                    self.drive = temp
                    self.tx_fifo.append([PWR_PWM,self.drive])
                elif button == 3 or button == 5:
                    temp = self.drive
                    if temp > 50: temp -= 10
                    elif temp > 10: temp -= 5
                    else: temp -= 1
                    if temp < 0: temp = 0
                    self.drive = temp
                    self.tx_fifo.append([PWR_PWM,self.drive])
            elif self.select_flag==6: # crick left triangle
                self.flip_flag |= 1 # set LSB
                if self.flip_flag == 1: # Lower 2nd bit = 0 = reverse bit
                    tx_acc = 0x80 | self.acc
                else:
                    tx_acc = 0x7F & self.acc
                self.tx_fifo.append([PWR_ACC,tx_acc])
            elif self.select_flag==7: # crick right triangle
                self.flip_flag = self.flip_flag & 2 # reset LSB
                if self.flip_flag == 2: # Lower 2nd bit = 1 = reverse bit
                    tx_acc = 0x80 | self.acc
                else:
                    tx_acc = 0x7F & self.acc
                self.tx_fifo.append([PWR_ACC,tx_acc])
            elif self.select_flag==2: # acc
                self.acc = updown(self.acc,126,button)
                tx_acc = self.flip_flag&1
                tx_acc ^= self.flip_flag>>1
                tx_acc = (tx_acc<<7) + self.acc
                self.tx_fifo.append([PWR_ACC,tx_acc])
            elif self.select_flag==3: # offset
                self.offset = updown(self.offset,126,button)
                self.tx_fifo.append([PWR_ZOF,self.offset])
            elif 4<= self.select_flag <= 5: # wob_t or wob_p
                if self.select_flag==4: # wob_t
                    self.wob_t = updown(self.wob_t,40,button,min=10,step=10)
                elif self.select_flag==5: # wob_p
                    self.wob_p = updown(self.wob_p,62,button)
                wob = self.wob_p & 0x3F
                if self.wob_t >= 40:
                    if wob == 0xFF:
                        wob = 0xFE
                    wob += 0xC0
                elif self.wob_t >=30:
                    wob += 0x80
                elif self.wob_t >=20:
                    wob += 0x40
                self.tx_fifo.append([PWR_WOB,wob])

        def get(self,item="v"): # item = "v"(pwm value),"m"(mA),"d"(direction),"a"(acceleration),"o"(offset),"t"(cycle time of wob),"p"(power of wob)
            item = item.lower()
            item0 = item[0]
            if item0 == "v":
                return self.drive
            elif item0 == "m":
                return self.current * 10 # current unit = 10mA
            elif item0 == "d":
                return self.flip_flag & 1
            elif item0 == "a":
                return self.acc
            elif item0 == "o":
                return self.offset
            elif item == "t":
                return self.wob_t
            elif item == "p":
                return self.wob_p

        def set(self,n,item="v"): # item = "v"(pwm value),"d"(direction),"a"(acceleration),"o"(offset),"t"(cycle time of wob),"p"(power of wob)
            item = item.lower()
            item0 = item[0]
            if item0 == "v":
                if n + self.offset > 200:
                    n = 200 - self.offset
                elif n < 0:
                    n = 0
                self.drive = n
                self.tx_fifo.append([PWR_PWM,n])
            elif item0 == "d":
                if n:
                    self.flip_flag |= 1 # Lower 2nd bit = 1 = reverse bit
                else:
                    self.flip_flag &= 0xFE
                if self.flip_flag == 0:
                    tx_acc = 0x7F & self.acc
                elif self.flip_flag == 1:
                    tx_acc = 0x80 | self.acc
                elif self.flip_flag == 2:
                    tx_acc = 0x80 | self.acc
                elif self.flip_flag == 3:
                    tx_acc = 0x7F & self.acc
                self.tx_fifo.append([PWR_ACC,tx_acc])
            elif item0 == "a":
                if n > 126:
                    n = 126
                elif n < 1:
                    n = 1
                self.acc = n
                tx_acc = self.flip_flag&1
                tx_acc ^= self.flip_flag>>1
                tx_acc = (tx_acc<<7) + self.acc
                self.tx_fifo.append([PWR_ACC,tx_acc])
            elif item0 == "o":
                if n > 126:
                    n = 126
                elif n < 0:
                    n = 0
                self.offset = n
                self.tx_fifo.append([PWR_ZOF,self.offset])
            elif item[0] == "t":
                if n >= 40:
                    n = 40
                elif n >= 30:
                    n = 30
                elif n >= 20:
                    n = 20
                elif n >= 10:
                    n = 10
                else:
                    n = 0
                self.wob_t = n
                wob = self.wob_p
                if self.wob_t >= 40:
                    if wob == 0xFF:
                        wob = 0xFE
                    wob += 0xC0
                elif self.wob_t >=30:
                    wob += 0x80
                elif self.wob_t >=20:
                    wob += 0x40
                self.tx_fifo.append([PWR_WOB,wob])
            if item[0] == "p":
                if n > 62:
                    n = 62
                elif n < 0:
                    n = 0
                self.wob_p = n
                wob = self.wob_p
                if self.wob_t >= 40:
                    if wob == 0xFF:
                        wob = 0xFE
                    wob += 0xC0
                elif self.wob_t >=30:
                    wob += 0x80
                elif self.wob_t >=20:
                    wob += 0x40
                self.tx_fifo.append([PWR_WOB,wob])

        def draw(self):
            draw_controller(str(self.number),self.x,self.y,self.w,\
                            self.h,self.color_index,self.flip_flag,self.drive,\
                            self.acc,self.offset,self.wob_t,self.wob_p,self.current)

            if (self.select_flag == 1):
                super().draw() # draw rectangle if selected
            elif (self.select_flag == 2):
                sx = self.x - 5
                sy = self.y + self.h + 2
                sw = 58
                sh = 20
                pygame.draw.rect(BACK_PANEL,colorlist[2],(sx,sy,sw,sh),2)
            elif (self.select_flag == 3):
                sx = self.x +51
                sy = self.y + self.h + 2
                sw = 80
                sh = 20
                pygame.draw.rect(BACK_PANEL,colorlist[2],(sx,sy,sw,sh),2)
            elif (self.select_flag == 4):
                sx = self.x -5
                sy = self.y + self.h + 20
                sw = 70
                sh = 20
                pygame.draw.rect(BACK_PANEL,colorlist[2],(sx,sy,sw,sh),2)
            elif (self.select_flag == 5):
                sx = self.x +63
                sy = self.y + self.h + 20
                sw = 60
                sh = 20
                pygame.draw.rect(BACK_PANEL,colorlist[2],(sx,sy,sw,sh),2)
            elif (self.select_flag == 6):
                p1 = (self.x-int(self.w/3),int(self.y+self.h/2))
                p2 = (self.x,self.y)
                p3 = (self.x,self.y+self.h)
                pygame.draw.polygon(BACK_PANEL,colorlist[2],(p1,p2,p3),2)
            elif (self.select_flag == 7):
                p1 = (self.x+self.w+int(self.w/3)-2,int(self.y+self.h/2))
                p2 = (self.x+self.w-2,self.y)
                p3 = (self.x+self.w-2,self.y+self.h)
                pygame.draw.polygon(BACK_PANEL,colorlist[2],(p1,p2,p3),2)

        def flip(self):
            self.flip_flag ^= 1

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y)) \
                + " " + str(int(self.color_index)) \
                + " " + str(int(self.flip_flag)) \
                + " " + str(int(self.drive)) \
                + " " + str(int(self.acc)) \
                + " " + str(int(self.offset)) \
                + " " + str(int(self.wob_t)) \
                + " " + str(int(self.wob_p)) \
                + " " + str(int(self.current)) \
                + "\n"
            return tempstr

    class Sensor(Base):
        def __init__(self,number,x,y,w=26,h=26,data = 0,select_flag=0):
            super().__init__(number,x,y,w,h)
            self.data = data
            self.dummy_sens = 0

        def tx(self,tx_list):
            tx_list.append(READ)

        def rx(self,rx_list):
            if len(rx_list) <= 0:
                print_TxRx_ERROR(14,self.number,[READ],[])
                return
            if rx_list[0]&0xFE == SENS_READ:
                if not self.select_flag:
                    self.dummy_sens = 0
                self.data = (rx_list[0] & 1) | self.dummy_sens
            else:
                print_TxRx_ERROR(15,self.number,[READ],[rx_list[0]])
            rx_list.pop(0)

        def mouse(self,button,pos):
            if self.select_flag:
                if button == 1:
                    self.dummy_sens ^= 1

        def get(self):
            return self.data
    
        def draw(self):
            draw_sensor(str(self.number),self.x,self.y,self.w,self.h,self.data)
            super().draw() # draw rectangle if selected

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y)) \
                + " " + str(int(self.data)) \
                + "\n"
            return tempstr

    class Signal3(Base):
        def __init__(self,number,x,y,w=26,h=26*3,flip_flag = 0,data = 1,select_flag=0):
            super().__init__(number,x,y,w,h)
            self.flip_flag = flip_flag
            self.data = data
            self.rt = 0
            self.yt = 0
            self.gt = 0
            self.sens_en = 1 # sensor enable
            self.tx_fifo = [[SIG3_SENS_EN+1]]
            self.com_loop_list = (READ,SIG3_RTR,READ,SIG3_RTY,READ,SIG3_RTG)
            self.com_loop_ptr = 0

        def tx(self,tx_list):
            if not self.tx_fifo: # tx_fifo空だったら
                self.tx_fifo.append([self.com_loop_list[self.com_loop_ptr]])
                self.com_loop_ptr += 1
                if self.com_loop_ptr >= len(self.com_loop_list):
                    self.com_loop_ptr = 0
            for com_byte in self.tx_fifo[0]:
                tx_list.append(com_byte)

        def rx(self,rx_list):
            if self.tx_fifo: t = self.tx_fifo[0][0]
            else: t = READ

            if len(rx_list) == 0:
                print_TxRx_ERROR(16,self.number,self.tx_fifo[0],[])
                return
            r = rx_list[0]
            if len(rx_list) == 1:
                print_TxRx_ERROR(17,self.number,self.tx_fifo[0],[r])
                rx_list.pop()
                return

            if t == READ and (r & 0xFC) == SIG3_READ:
                self.data = r & 3
            elif (t & 0xFC) == SIG3_W:
                None
            elif t == SIG3_RTR:
                self.rt = r
            elif t == SIG3_RTY:
                self.yt = r
            elif t == SIG3_RTG:
                self.gt = r
            elif (t & 0xFE) == SIG3_SENS_EN:
                if t == r:
                    None
                else:
                    print_TxRx_ERROR(18,self.number,self.tx_fifo[0],[rx_list[0],rx_list[1]])
            elif SIG3_WTR <= t <= SIG3_WTG:
                if self.tx_fifo[0] == [rx_list[0],rx_list[1]]:
                    rx_list.pop(0)
                else:
                    print_TxRx_ERROR(19,self.number,self.tx_fifo[0],[rx_list[0],rx_list[1]])
            else:
                print_TxRx_ERROR(20,self.number,[t],[r])

            rx_list.pop(0)
            if self.tx_fifo:
                self.tx_fifo.pop(0)

        def select(self,pos):
            self.select_flag = 0
            dh = self.h/3
            if pos[0] < self.x-50 or self.x+self.w+50 < pos[0]:
                return
            if pos[1] < self.y-dh or self.y+self.h < pos[1]:
                return
            if self.x <= pos[0] <= self.x+self.w:
                if pos[1] < self.y:
                    return
                if pos[1] < self.y+dh:
                    self.select_flag = 3 # green
                elif  pos[1] < self.y+2*dh:
                    self.select_flag = 2 # yellow
                elif pos[1] <= self.y+self.h:
                    self.select_flag = 1 # red
            elif option_ON:
                if self.flip_flag:
                    if self.x-50 <= pos[0] < self.x:
                        if pos[1] < self.y-dh:
                            return
                        elif pos[1] < self.y:
                            self.select_flag = 7 # switch enable
                        elif pos[1] < self.y+dh:
                            self.select_flag = 6 # green timer
                        elif pos[1] < self.y+2*dh:
                            self.select_flag = 5 # yellow timer
                        elif pos[1] <= self.y+self.h:
                            self.select_flag = 4 # red timer
                else:
                    if self.x < pos[0] <= self.x+self.w+50:
                        if pos[1] < self.y-dh:
                            return
                        elif pos[1] < self.y:
                            self.select_flag = 7 # switch enable
                        elif pos[1] < self.y+dh:
                            self.select_flag = 6 # green timer
                        elif pos[1] < self.y+2*dh:
                            self.select_flag = 5 # yellow timer
                        elif pos[1] <= self.y+self.h:
                            self.select_flag = 4 # red timer

        def mouse(self,button,pos):
            if 1 <= self.select_flag <= 3:
                self.data = self.select_flag
                self.tx_fifo.append([SIG3_W+self.data])
            elif self.select_flag == 4:
                self.rt = updown(self.rt,254,button)
                self.tx_fifo.append([SIG3_WTR,self.rt])
            elif self.select_flag == 5:
                self.yt = updown(self.yt,254,button)
                self.tx_fifo.append([SIG3_WTY,self.yt])
            elif self.select_flag == 6:
                self.gt = updown(self.gt,254,button)
                self.tx_fifo.append([SIG3_WTG,self.gt])
            elif self.select_flag == 7:
                self.sens_en ^= 1
                self.tx_fifo.append([SIG3_SENS_EN+self.sens_en])

        def get(self):
            return self.data

        def set(self,d):
            d &= 0x03
            self.data = d
            self.tx_fifo.append([SIG3_W+d])

        def flip(self):
            self.flip_flag ^= 1

        def rotate(self):
            self.data += 1
            if self.data > 3:
                self.data = 0

        def draw(self):
            draw_signal3(self.x,self.y,self.flip_flag,self.w,self.h,self.data)
            if self.sens_en :sens_en_num = self.number + 1
            else: sens_en_num = -(self.number + 1)
            draw_signal3_t(str(self.number),self.x,self.y,self.flip_flag,self.w,self.h,\
                           self.rt,self.yt,self.gt,sens_en_num)
            if self.select_flag <= 3:
                super().draw() # draw rectangle if selected
            elif self.flip_flag:
                if self.select_flag == 7:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-60,self.y-self.h/3,60,self.h/3),2)
                elif self.select_flag == 6:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y,50,self.h/3),2)
                elif self.select_flag == 5:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h/3,50,self.h/3),2)
                elif self.select_flag == 4:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h/3*2,50,self.h/3),2)
            else:
                if self.select_flag == 7:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w-5,self.y-self.h/3,60,self.h/3),2)
                elif self.select_flag == 6:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y,50,self.h/3),2)
                elif self.select_flag == 5:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h/3,50,self.h/3),2)
                elif self.select_flag == 4:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h/3*2,50,self.h/3),2)

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y)) \
                + " " + str(int(self.flip_flag)) \
                + " " + str(int(self.data)) \
                + "\n"
            return tempstr

    class Signal6(Base):
        def __init__(self,number,x,y,w=26*2,h=26*3.5,flip_flag = 0,data = 5,select_flag=0):
            super().__init__(number,x,y,w,h,select_flag)
            self.flip_flag = flip_flag
            self.data = data
            self.r1t = 0
            self.y1t = 0
            self.g1t = 0
            self.r2t = 0
            self.y2t = 0
            self.g2t = 0
            self.sens_en1 = 1
            self.sens_en2 = 1
            self.evp = 0
            self.wait = 0
            self.tx_fifo = [[SIG6_1_SENS_EN+1],[SIG6_2_SENS_EN+1]]
            self.com_loop_list = (\
                READ,SIG6_REVP,\
                READ,SIG6_1_RTR,\
                READ,SIG6_1_RTY,\
                READ,SIG6_1_RTG,\
                READ,SIG6_2_RTR,\
                READ,SIG6_2_RTY,\
                READ,SIG6_2_RTG,\
                READ,SIG6_RWAIT,)
            self.com_loop_ptr = 0

        def tx(self,tx_list):
            if not self.tx_fifo: # tx_fifo空だったら
                self.tx_fifo.append([self.com_loop_list[self.com_loop_ptr]])
                self.com_loop_ptr += 1
                if self.com_loop_ptr >= len(self.com_loop_list):
                    self.com_loop_ptr = 0
            for com_byte in self.tx_fifo[0]:
                tx_list.append(com_byte)

        def rx(self,rx_list):
            if self.tx_fifo: t = self.tx_fifo[0][0]
            else: t = READ
            if len(rx_list) == 0:
                print_TxRx_ERROR(21,self.number,[t],[])
                return
            elif len(rx_list) == 1:
                print_TxRx_ERROR(22,self.number,[t],[rx_list[0]])
                rx_list.pop()
                return
            r = rx_list[0]
            if t == READ and (r & 0xF0) == SIG6_READ:
                self.data = r & 0xF
            elif (t & 0xF0) == SIG6_W:
                None
            elif (t & 0xFE) == SIG6_1_SENS_EN:
                if t == r:
                    None
                else:
                    print_TxRx_ERROR(23,self.number,[t],[rx_list[0]])
            elif (t & 0xFE) == SIG6_2_SENS_EN:
                if t == r:
                    None
                else:
                    print_TxRx_ERROR(24,self.number,[self.tx_fifo[0]],[rx_list[0]])
            elif t == SIG6_REVP and SIG6_REVP&0xF8 == r&0xF8:
                self.evp = r&0x7 # evp each bit = 1 if Jumper pin off or switch input=High on SIG6_S circuit board.
            elif t == SIG6_1_RTR:
                self.r1t = r
            elif t == SIG6_1_RTY:
                self.y1t = r
            elif t == SIG6_1_RTG:
                self.g1t = r
            elif t == SIG6_2_RTR:
                self.r2t = r
            elif t == SIG6_2_RTY:
                self.y2t = r
            elif t == SIG6_2_RTG:
                self.g2t = r
            elif t == SIG6_RWAIT:
                self.wait = r
            elif SIG6_1_WTR <= t <= SIG6_WWAIT:
                rx_list.pop(0)
            else:
                print_TxRx_ERROR(25,self.number,[t],[r])

            rx_list.pop(0)
            if self.tx_fifo:self.tx_fifo.pop(0)

        def select(self,pos):
            self.select_flag = 0
            if pos[0] < self.x-50 or self.x+self.w+50 < pos[0]:
                return
            dh = self.h/3.5
            if self.flip_flag:
                d1 = dh/2
                d2 = 0
            else:
                d1 = 0
                d2 = dh/2
            if self.y <= pos[1] < self.y+self.h:
                if self.x <= pos[0] < self.x+self.w/2:
                    if pos[1] < self.y+dh+d2:
                        self.select_flag = 3 # G1
                    elif pos[1] < self.y+2*dh+d2:
                        self.select_flag = 2 # Y1
                    else:
                        self.select_flag = 1 # R1
                    return
                elif self.x+self.w/2 <= pos[0] < self.x+self.w:
                    if pos[1] < self.y+dh+d1:
                        self.select_flag = 6 # G2
                    elif pos[1] < self.y+2*dh+d1:
                        self.select_flag = 5 # Y2
                    else:
                        self.select_flag = 4 # R2
                    return
            if option_ON:
                if self.y-dh+d2 <= pos[1] < self.y+3*dh+d2:
                    if self.x-50 <= pos[0] < self.x:
                        if pos[1] <= self.y+d2:
                            self.select_flag = 13 # switch1 enable
                        elif pos[1] < self.y+dh+d2:
                            self.select_flag = 9 # G1T
                        elif pos[1] < self.y+2*dh+d2:
                            self.select_flag = 8 # Y1T
                        else:
                            self.select_flag = 7 # R1T
                        return
                if self.y-dh+d1 <= pos[1] < self.y+3*dh+d1:
                    if self.x+self.w < pos[0] <= self.x+self.w+50:
                        if pos[1] <= self.y+d1:
                            self.select_flag = 14 # switch1 enable
                        elif pos[1] < self.y+dh+d1:
                            self.select_flag = 12 # G2T
                        elif pos[1] < self.y+2*dh+d1:
                            self.select_flag = 11 # Y2T
                        else:
                            self.select_flag = 10 # R2T
                        return
                if self.y+self.h <= pos[1] < self.y+self.h+26:
                    if self.x+20 < pos[0] <= self.x+90:
                        self.select_flag = 15 # WAIT
                        return

        def mouse(self,button,pos):
            if self.select_flag > 0:
                if self.select_flag <= 3:
                    self.data = (self.data & 0x3) | (self.select_flag<<2);
                    self.tx_fifo.append([SIG6_W + self.data])
                elif self.select_flag <= 6:
                    self.data = (self.select_flag-3) | (self.data & 0xC);
                    self.tx_fifo.append([SIG6_W + self.data])
                elif self.select_flag == 7:
                    self.r1t = updown(self.r1t,254,button)
                    self.tx_fifo.append([SIG6_1_WTR,self.r1t])
                elif self.select_flag == 8:
                    self.y1t = updown(self.y1t,254,button)
                    self.tx_fifo.append([SIG6_1_WTY,self.y1t])
                elif self.select_flag == 9:
                    self.g1t = updown(self.g1t,254,button)
                    self.tx_fifo.append([SIG6_1_WTG,self.g1t])
                elif self.select_flag == 10:
                    self.r2t = updown(self.r2t,254,button)
                    self.tx_fifo.append([SIG6_2_WTR,self.r2t])
                elif self.select_flag == 11:
                    self.y2t = updown(self.y2t,254,button)
                    self.tx_fifo.append([SIG6_2_WTY,self.y2t])
                elif self.select_flag == 12:
                    self.g2t = updown(self.g2t,254,button)
                    self.tx_fifo.append([SIG6_2_WTG,self.g2t])
                elif self.select_flag == 13:
                    self.sens_en1 ^= 1
                    self.tx_fifo.append([SIG6_1_SENS_EN+self.sens_en1])
                elif self.select_flag == 14:
                    self.sens_en2 ^= 1
                    self.tx_fifo.append([SIG6_2_SENS_EN+self.sens_en2])
                elif self.select_flag == 15:
                    self.wait = updown(self.wait,254,button)
                    self.tx_fifo.append([SIG6_WWAIT,self.wait])


        def get(self):
            return self.data

        def set(self,d):
            d &= 0x0F
            self.data = 0x0F & d
            self.tx_fifo.append([SIG6_W+d])

        def flip(self):
            self.flip_flag ^= 1

        def rotate(self):
            self.data += 1
            if self.data > 15:
                self.data = 0

        def draw(self):
            if self.sens_en1 :sens_en1 = self.number + 1
            else: sens_en1 = 0
            if self.sens_en2 :sens_en2 = self.number + 1
            else: sens_en2 = 0
            draw_signal6(str(self.number),self.x,self.y,self.flip_flag,self.w,self.h,self.data,\
                         self.r1t,self.y1t,self.g1t,self.r2t,self.y2t,self.g2t\
                         ,sens_en1,sens_en2,self.evp,self.wait)
            if self.select_flag <= 6:
                super().draw() # draw rectangle if selected
            if self.select_flag == 15:
                pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+20,self.y+self.h-5,70,self.h/3.5),2)
            elif self.flip_flag:
                if self.select_flag == 13:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-60,self.y-self.h/3.5,60,self.h/3.5),2)
                elif self.select_flag == 14:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w-5,self.y-self.h*0.5/3.5,60,self.h/3.5),2)
                elif self.select_flag == 9:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y,50,self.h/3.5),2)
                elif self.select_flag == 8:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h/3.5,50,self.h/3.5),2)
                elif self.select_flag == 7:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h*2/3.5,50,self.h/3.5),2)
                if self.select_flag == 12:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h*0.5/3.5,50,self.h/3.5),2)
                elif self.select_flag == 11:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h*1.5/3.5,50,self.h/3.5),2)
                elif self.select_flag == 10:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h*2.5/3.5,50,self.h/3.5),2)
            else:
                if self.select_flag == 13:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-60,self.y-self.h*0.5/3.5,60,self.h/3.5),2)
                elif self.select_flag == 14:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w-5,self.y-self.h/3.5,60,self.h/3.5),2)
                elif self.select_flag == 9:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h*0.5/3.5,50,self.h/3.5),2)
                elif self.select_flag == 8:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h*1.5/3.5,50,self.h/3.5),2)
                elif self.select_flag == 7:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x-50,self.y+self.h*2.5/3.5,50,self.h/3.5),2)
                if self.select_flag == 12:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y,50,self.h/3.5),2)
                elif self.select_flag == 11:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h/3.5,50,self.h/3.5),2)
                elif self.select_flag == 10:
                    pygame.draw.rect(BACK_PANEL,colorlist[2],(self.x+self.w,self.y+self.h*2/3.5,50,self.h/3.5),2)

        def string(self):
            tempstr = "{:4}".format(self.number) \
                + " " + self.__class__.__name__ \
                + " " + str(int(self.x)) \
                + " " + str(int(self.y)) \
                + " " + str(int(self.flip_flag)) \
                + " " + str(int(self.data)) \
                + "\n"
            return tempstr

    def find_facility(xpos,ypos):
        findlist = []
        for i in range(len(facilities)):
            w = facilities[i].w
            h = facilities[i].h
            x = facilities[i].x
            y = facilities[i].y
            if x <= xpos <= x+w:
                if y <= ypos <= y+h:
                    findlist.append(i)
        return findlist

    def print_help():
        print()
        print("【GUI help for SNTC2 N guage control system by ik-gadgets】")
        print()
        print(" n または Nキーを押すとポイント、信号機、センサー、コントローラーのID番号(シリアルネットワークの接続順)の表示をON/OFFできる。")
        print()
        print(" 信号機の点灯色を変えたい場合は光らせたいランプの上にマウスポインタを持ってきてクリックする。")
        print()
        print(" 3角形アイコンのポイントまたはスイッチの接続方向を切り替えるにはマウスポインタを３角形アイコン上に持ってきてクリックする。")
        print()
        print(" コントローラーのドライブ数値(列車の駆動力)を変えるにはマウスポインタをコントローラーの上に持ってきてマウスのホイールを回すか、左ボタン(増速)または右ボタン(減速)をクリックする。")
        print()
        print(" コントローラーのAcc(加速度)、Offset(0近辺の不感帯のスキップ)、WobT(駆動力Wobblingの時間幅)、WobS(駆動力Wobblingの強さ)を変更するにはそれぞれその上にマウスポインタを持ってきてマウスボタンまたはホイールで変更する。")
        print()
        print(" 列車の走行方向を変えるにはコントローラーの三角印の上にマウスポインタを持ってきてクリックする。")
        print()
        print(" センサ(緑の正方形にSの字)の上にマウスポインタを持ってきてクリックするとセンサ出力をON/OFFできる。")
        print()
        print(" Hまたはhキーでコマンドウインドウ側にこのHelpを表示する。")
        print()

    def search_control_file():
        file_head = "control_panel_"
        for file_No in range(100,0,-1):
            file_name = file_head + str(file_No) + ".txt"
            if os.path.exists(file_name):
                return file_name
        return None

    def get_write_file_name():
        file_head = "control_panel_"
        file_No = 0
        while(1):
            file_No += 1
            file_name = file_head + str(file_No) + ".txt"
            if not os.path.exists(file_name):
                return file_name
            if file_No == 100:
                print("### WARNING ### overwrite ",file_name)
                return file_name

    def writefile():
        global window_h
        global window_w
        global grid_unit
        global lines
        global file_name

        head_lines = []
        line_lines = []
        text_lines = []
        facility_str = []
        print()
        file_name = get_write_file_name()
        print("Output file = ",file_name)
        print()

        head_lines.append("window_w " + str(window_w) + "\n")
        head_lines.append("window_h " + str(window_h) + "\n")
        head_lines.append("grid " + str(grid_unit) + "\n")

        for L in lines:
            line_lines.append("line "+ str(int(L.x1)) +" "+ str(int(L.y1)) +" "+ str(int(L.x2)) +" "+ str(int(L.y2)) +" "+ str(L.color_index) + "\n")

        for T in text_list:
            text_lines.append(T.string())

        facility_lines = []
        tile_lines = []
        number_list = []
        number_max = 0
        for facility in facilities:
            i = facility.number
            errstr = ""
            tmpstr = ""
            if facility.__class__.__name__ != "Tile":
                if i <= 0:
                    errstr = "### ERROR ### id number <= 0\n"
                    print(errstr,end="")
                elif i in number_list:
                    errstr = "### ERROR ### Duplicate id number = " + str(i) + "\n"
                    print(errstr,end="")
                number_list.append(i)
                if i > number_max: number_max = i
                tempstr = facility.string()
                facility_lines.append(tempstr.lower() + errstr)
            else:
                tempstr = facility.string()
                tile_lines.append(tempstr.lower() + errstr)

        for i in range(1,number_max+1):
            if i not in number_list:
                errstr = "### ERROR ### Missing id number = " + str(i) + "\n"
                print(errstr,end="")
                facility_lines.append(errstr)

        facility_lines.sort()

        f = open(file_name, 'w', encoding='UTF-8')
        f.writelines(head_lines)
        f.writelines(text_lines)
        f.writelines(facility_lines)
        f.writelines(line_lines)
        f.writelines(tile_lines)
        f.close()

    def read_line_error(line_No,errline):
        print("### ERROR ###: line ",line_No,":",errline)
        pygame.quit()
        print()
        sys.exit()

    def check_facility_number():
        number_max = 0
        number_list=[]
        for facility in facilities:
            i = facility.number
            if facility.__class__.__name__ != "Tile":
                if i <= 0:
                    print("### ERROR ### ID number = 0")
                elif i in number_list:
                    print("### ERROR ### Duplicate id number = " + str(i))
                number_list.append(i)
                if i > number_max: number_max = i
        for i in range(1,number_max+1):
            if i not in number_list:
                print("### ERROR ### Missing id number = " + str(i))

    def readfile(file_list):
        global window_h
        global window_w
        global grid_unit
        global lines
        global facilities
        global text_list

        time.sleep(0.5)
        datalist = []
        print()
        for file in file_list:
          f = open(file,'r',encoding='UTF-8')
          datalist = datalist + f.readlines()
          f.close()
          print("input file = ",file)
        print()

        lines = []
        facilities = []
        text_list = []

        readline_cnt = 0
        lines = []
        for data in datalist:
            readline_cnt += 1
            print(str(readline_cnt),":",data,end="")
            tempdata = re.sub('#.*','',data)
            tempdata = tempdata.lower()
            splitdata = tempdata.split()
            if len(splitdata) == 0:
                continue
            elif len(splitdata) < 2:
                read_line_error(readline_cnt,data)
            elif splitdata[0] == "window_w":
                if len(splitdata) == 2:
                    window_w = int(splitdata[1])
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[0] == "window_h":
                if len(splitdata) == 2:
                    window_h = int(splitdata[1])
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[0] == "grid":
                if len(splitdata) == 2:
                    grid_unit = int(splitdata[1])
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[0] == "text":
                if len(splitdata) >= 8:
                    xxx = re.search(r'"(.+)"',data)
                    if xxx:
                        textstr = xxx.group(1)
                    else:
                        textstr = splitdata[7]
                    text_list.append(Text(
                            x=int(splitdata[1]),\
                            y=int(splitdata[2]),\
                            font_name=splitdata[3],\
                            font_size=int(splitdata[4]),\
                            bold=int(splitdata[5]),\
                            color_index=int(splitdata[6]),\
                            text=textstr))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[0] == "line":
                if len(splitdata) == 6:
                    lines.append(
                        Line(\
                            int(splitdata[1]),\
                            int(splitdata[2]),\
                            int(splitdata[3]),\
                            int(splitdata[4]),\
                            int(splitdata[5])\
                        )
                    )
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "tile":
                if len(splitdata) == 7:
                    facilities.append(Tile(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),w=int(splitdata[4]),h=int(splitdata[5]),color_index=int(splitdata[-1])))
                elif len(splitdata) == 5:
                    facilities.append(Tile(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),\
                            image_file=splitdata[4]))
                elif len(splitdata) == 8:
                    facilities.append(Tile(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),\
                            flip_flag=int(splitdata[4]),rotate_angle=int(splitdata[5]),k=int(splitdata[6]),\
                            image_file=splitdata[7]))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "point":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 6:
                    angle = int(splitdata[5])
                    angle /= 90
                    angle = int(angle)*90
                    angle %= 360
                    facilities.append(Point(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),flip_flag=int(splitdata[4]),rotate_angle=angle))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "switch":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 6:
                    angle = int(splitdata[5])
                    angle /= 90
                    angle = int(angle)*90
                    angle %= 360
                    facilities.append(Switch(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),flip_flag=int(splitdata[4]),rotate_angle=angle))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "point_slow":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 6:
                    angle = int(splitdata[5])
                    angle /= 90
                    angle = int(angle)*90
                    angle %= 360
                    facilities.append(Point_slow(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),flip_flag=int(splitdata[4]),rotate_angle=angle))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "controller":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 12:
                    facilities.append(Controller(
                        number = int(splitdata[0]),\
                        x = int(splitdata[2]),\
                        y = int(splitdata[3]),\
                        color_index = int(splitdata[4]),\
                        flip_flag = int(splitdata[5]),\
                        drive = int(splitdata[6]),\
                        acc = int(splitdata[7]),\
                        offset = int(splitdata[8]),\
                        wob_t = int(splitdata[9]),\
                        wob_p = 0xFE & int(splitdata[10]),\
                        current = int(splitdata[11])\
                        )
                    )
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "sensor":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 5:
                    facilities.append(Sensor(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),data=int(splitdata[4])))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "signal3":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 6:
                    facilities.append(Signal3(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),\
                                              flip_flag=int(splitdata[4]),data=int(splitdata[5])))
                else:
                    read_line_error(readline_cnt,data)
            elif splitdata[1] == "signal6":
                add_No(int(splitdata[0]),len(facilities))
                if len(splitdata) == 6:
                    facilities.append(Signal6(int(splitdata[0]),int(splitdata[2]),int(splitdata[3]),\
                                              flip_flag=int(splitdata[4]),data=int(splitdata[5])))
                else:
                    print("### ERROR ### line ",readline_cnt,":",datalist[readline_cnt-1])
                    pygame.quit()
            else:
                read_line_error(readline_cnt,data)
        check_facility_number()
        print()
        for file in file_list:
          print("loaded input file = ",file)
        print()

    def draw_back():
        global window_w
        global window_h
        global grid_unit

        # 背景色で塗りつぶし
        BACK_PANEL.fill((200, 200, 200))

        # 点を描画
        if grid_on:
            for ypos in range(0, window_h - 60, grid_unit):
                for xpos in range(0, window_w, grid_unit):
                    pygame.draw.ellipse(BACK_PANEL, (64,64,64),(xpos,ypos,2,2))

    def draw_controller(No_str,x,y,w,h,color_index,flip_flag,drive,acc,offset,wob_t,wob_p,current):
        color = colorlist[color_index]
        drv_str = "{0:>3}".format(drive)
        if flip_flag & 1:
            L_fill,R_fill = 0,2
        else:
            L_fill,R_fill = 2,0
        # 中央の四角
        pygame.draw.rect(BACK_PANEL,color,(x,y,w,h),3)
        # 左の三角
        pygame.draw.polygon(BACK_PANEL,color,((x,y),(x,y+h),(x-int(w/3),y+int(h/2))),L_fill)
        # 右の三角
        pygame.draw.polygon(BACK_PANEL,color,((x+w,y),(x+w,y+h),(x+w+int(w/3),y+int(h/2))),R_fill)

        if number_ON:
            if flip_flag & 2:
                bmp = Nofont.render(No_str, True, colorlist[9])
            else:
                bmp = Nofont.render(No_str, True, colorlist[0])
            BACK_PANEL.blit(bmp,(x,y-int(h/2)))

        if acc > 0:
            bmp = controlfont.render(drv_str, True, color)
            BACK_PANEL.blit(bmp,(x+int(w/8),y+int(h/8)))
        else:
            bmp = controlfont.render("N/A", True, colorlist[2])
            BACK_PANEL.blit(bmp,(x+int(w/8),y+int(h/8)))

        # Acc 0-126,0=Manual mode
        # Offset 0-126
        # Wob: 10,20,30,40ms/100,200,300,400ms, 0-62
        if acc == 0:
            bmp = optionfont.render("Acc:{:<3}".format(acc), True, colorlist[2])
        else:
            bmp = optionfont.render("Acc:{:<3}".format(acc), True, colorlist[0])
        BACK_PANEL.blit(bmp,(x,y+h+5))
        if option_ON:
            bmp = optionfont.render(" Offset:{:<2}".format(offset), True, colorlist[0])
            BACK_PANEL.blit(bmp,(x+50,y+h+5))
            bmp = optionfont.render("WobT:{:<2}ms WobP:{:<2}".format(wob_t,wob_p), True, colorlist[0])
            BACK_PANEL.blit(bmp,(x,y+h+23))
            # current
            bmp = optionfont.render("{:>4}mA".format(current*10), True, colorlist[0])
            BACK_PANEL.blit(bmp,(x+50,y-15))

    def draw_point(No_str,x,y,w,h,flip,rotate,name,tx_flip):
        move_flag = (flip & 1) ^ tx_flip
        if flip & 2:
            move_flag ^= 1
        line_width = 6
        if name == "Point":
            fill_color = (189,183,107)
        elif name == "Point_slow":
            fill_color = (107,183,189)
        else: # Switch
            fill_color = (255,69,0)

        if number_ON:
            if flip & 2:
                bmp = Nofont.render(No_str, True, colorlist[9])
            else:
                bmp = Nofont.render(No_str, True, colorlist[0])
        else:
            bmp = Nofont.render("", True, colorlist[0])

        if flip & 1:
            if rotate == 0:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x,y+h/2),(x+w,y),(x+w,y+h)))
                if move_flag: p = y + h/2
                else: p = y + h
                pygame.draw.line(BACK_PANEL,colorlist[0],(x,y+h/2),(x+w,p),width=line_width)
                BACK_PANEL.blit(bmp, (x+w/2+6,y+h/2-12))
            elif rotate == 90:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+h/2,y),(x+h,y+w),(x,y+w)))
                if move_flag: p = x + h/2
                else: p = x
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+h/2,y),(p,y+w),width=line_width)
                BACK_PANEL.blit(bmp, (x+h/2-6,y+w/2-6))
            elif rotate == 180:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+w,y+h/2),(x,y+h),(x,y)))
                if move_flag: p = y + h/2
                else: p = y
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+w,y+h/2),(x,p),width=line_width)
                BACK_PANEL.blit(bmp, (x+w/2-16,y+h/2-12))
            elif rotate == 270:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+h/2,y+w),(x,y),(x+h,y)))
                if move_flag: p = x + h/2
                else: p = x + h
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+h/2,y+w),(p,y),width=line_width)
                BACK_PANEL.blit(bmp, (x+h/2-6,y+w/2-20))
        else:
            if rotate == 0:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x,y+h/2),(x+w,y),(x+w,y+h)))
                if move_flag: p = y + h/2
                else: p = y
                pygame.draw.line(BACK_PANEL,colorlist[0],(x,y+h/2),(x+w,p),width=line_width)
                BACK_PANEL.blit(bmp, (x+w/2+6,y+h/2-12))
            elif rotate == 90:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+h/2,y),(x+h,y+w),(x,y+w)))
                if move_flag: p = x + h/2
                else: p = x + h
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+h/2,y),(p,y+w),width=line_width)
                BACK_PANEL.blit(bmp, (x+h/2-6,y+w/2-6))
            elif rotate == 180:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+w,y+h/2),(x,y+h),(x,y)))
                if move_flag: p = y + h/2
                else: p = y + h
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+w,y+h/2),(x,p),width=line_width)
                BACK_PANEL.blit(bmp, (x+w/2-16,y+h/2-12))
            elif rotate == 270:
                pygame.draw.polygon(BACK_PANEL,fill_color,((x+h/2,y+w),(x,y),(x+h,y)))
                if move_flag: p = x + h/2
                else: p = x
                pygame.draw.line(BACK_PANEL,colorlist[0],(x+h/2,y+w),(p,y),width=line_width)
                BACK_PANEL.blit(bmp, (x+h/2-6,y+w/2-20))

    def draw_sensor(No_str,x,y,w,h,data):
        Green = (0,100,0)
        Magenta = (255,0,255)
        if data:
            pygame.draw.rect(BACK_PANEL,Magenta,(x,y,w,h),0)
        else:
            pygame.draw.rect(BACK_PANEL,Green,(x,y,w,h),0)
        bmp = Nofont.render('s', True, colorlist[9])
        BACK_PANEL.blit(bmp, (int(x+w/3.5),int(y-h/8)))
        if number_ON:
            bmp = Nofont.render(No_str, True, colorlist[0])
            BACK_PANEL.blit(bmp, (x,y-26))

    def draw_signal3_t(No_str,x,y,flip,w,h,rt,yt,gt,sens_en_num):
        if number_ON:
            bmp = Nofont.render(No_str, True, colorlist[0])
            BACK_PANEL.blit(bmp,(x,y-25))
        if option_ON:
            dh = h/12
            sens_en_str = "S"
            if sens_en_num > 0:
                sens_en_str += str(sens_en_num)+":"
                sens_en_str += "ON"
            else:
                sens_en_str += str(-sens_en_num)+":"
                sens_en_str += "OFF"
            if flip == 0:
                bmp = optionfont.render("{0:<.1f}s".format(gt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x+w+6,y+dh))
                bmp = optionfont.render("{0:<.1f}s".format(yt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x+w+6,y+h/3+dh))
                bmp = optionfont.render("{0:<.1f}s".format(rt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x+w+6,y+h/3*2+dh))
                bmp = optionfont.render(sens_en_str, True, colorlist[0])
                BACK_PANEL.blit(bmp, (x+w,y-h/4))
            else:
                bmp = optionfont.render("{0:>5.1f}s".format(gt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x-45,y+dh))
                bmp = optionfont.render("{0:>5.1f}s".format(yt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x-45,y+h/3+dh))
                bmp = optionfont.render("{0:>5.1f}s".format(rt*0.5), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x-45,y+h*2/3+dh))
                bmp = optionfont.render("{0:>8}".format(sens_en_str), True, colorlist[0])
                BACK_PANEL.blit(bmp, (x-60,y-h/4))

    def draw_signal3(x,y,flip,w,h,data):
        lamp_G = colorlist[0]
        lamp_Y = lamp_G
        lamp_R = lamp_G
        if data == 3:
            lamp_G = (0,255,255)
        elif data == 2:
            lamp_Y = (255,255,000)
        elif data == 1:
            lamp_R = (255,0,0)
        y += int(h/6)
        if flip:
            delta = 9
        else:
            delta = -9
        pygame.draw.rect(BACK_PANEL,(150,150,150),(x+delta,y,w,int(h*2/3)),0)
        pygame.draw.circle(BACK_PANEL,(150,150,150),(x+delta+w/2,y),w/2,0)
        pygame.draw.circle(BACK_PANEL,(150,150,150),(x+delta+w/2,y+h*2/3),w/2,0)

        pygame.draw.rect(BACK_PANEL,(60,60,60),(x,y,w,int(h*2/3)),0)
        pygame.draw.circle(BACK_PANEL,(60,60,60),(x+w/2,y),w/2,0)
        pygame.draw.circle(BACK_PANEL,(60,60,60),(x+w/2,y+h*2/3),w/2,0)

        pygame.draw.circle(BACK_PANEL,lamp_G,(x+w/2,y),w/2.2,0)
        pygame.draw.circle(BACK_PANEL,lamp_Y,(x+w/2,y+h/3),w/2.2,0)
        pygame.draw.circle(BACK_PANEL,lamp_R,(x+w/2,y+h*2/3),w/2.2,0)

    def draw_signal6(No_str,x,y,flip,w,h,data,r1t,y1t,g1t,r2t,y2t,g2t,\
                     sens_en1,sens_en2,evp,wait):
        dataL = data>>2
        dataR = data & 3
        if flip:
            offsetL = 0
            offsetR = h/7
            draw_signal3(x,y+offsetL,flip,w/2,h*6/7,dataL)
            draw_signal3(x+w/2,y+offsetR,flip,w/2,h*6/7,dataR)
        else:
            offsetL = h/7
            offsetR = 0
            draw_signal3(x+w/2,y+offsetR,flip,w/2,h*6/7,dataR)
            draw_signal3(x,y+offsetL,flip,w/2,h*6/7,dataL)
        number = int(No_str)
        if sens_en1 :sens_en1_num = number + 1
        else: sens_en1_num = -(number + 1)
        if sens_en2 :sens_en2_num = number + 2
        else: sens_en2_num = -(number + 2)
        draw_signal3_t(No_str,x,y+offsetL,1,w/2,h*6/7,r1t,y1t,g1t,sens_en1_num)
        draw_signal3_t("",x+w/2,y+offsetR,0,w/2,h*6/7,r2t,y2t,g2t,sens_en2_num)
        if option_ON:
            bmp = optionfont.render("evp:{0:03b}".format(evp), True, colorlist[0])
            BACK_PANEL.blit(bmp,(x-30,y+h))
            bmp = optionfont.render("wait:{0:.1f}s".format(wait*0.5), True, colorlist[0])
            BACK_PANEL.blit(bmp,(x+25,y+h))

    def write_bottom_column(key,colorindex):
        global window_w
        global window_h
        global string1
        global string2
        global sysfont

        rect_line1 = pygame.draw.rect(BACK_PANEL, (255,255,255),(0, window_h-60, window_w, 60))
        if key == 0: # erase error string on mouse button down
            string1 = ""
            string2 = ""
        elif key in command_key_list:
            command = command_key_list.index(key)
            string1 = command_string_list[command]
            string2 = ""
            if key == K_w:
                string1 += file_name
            if key == K_r:
                string1 += " = " + file_name
        elif K_0 <= key <= K_9:
            string2 = ""
        else:
            try:
                string1 = "### ERROR ###  Input key = " + chr(key)
                string2 = "                   Usable keys ="
                for c in command_key_list:
                    string2 += " " + chr(c)
            except ValueError as error:
                string2 = ""
        bmp = sysfont.render(string1, True, (0, 0, 0))
        BACK_PANEL.blit(bmp, (20, window_h-50))
        bmp = sysfont.render(string2, True, (0, 0, 0))
        BACK_PANEL.blit(bmp, (20, window_h-25))


    ### functions for user train control programing ###

    def auto_read(i,item=None):
        global facilities
        j = No2objid[i]
        f = facilities[j]
        if beep_flag&1:
            winsound.Beep(2000,50)
        if item is None:
            r = f.get()
            if com_print_flag & 1:
                print(" read",f.number,f.__class__.__name__,r)
        else:
            r = f.get(item)
            if com_print_flag & 1:
                print(" read",f.number,f.__class__.__name__,r,item)
        return r 

    def auto_write(i,d,item=None):
        global eventflag
        global tx_trigger_flag
        j = No2objid[i]
        f = facilities[j]
        if item is None:
            f.set(d)
            if com_print_flag & 2:
                print("write",f.number,f.__class__.__name__,d)
        else:
            f.set(d,item)
            if com_print_flag & 2:
                print("write",f.number,f.__class__.__name__,d,item)

        tx_trigger_flag += 1
        eventflag += 1
        if beep_flag&2:
            winsound.Beep(1000,50)

    def auto_check(i,item=None,new=None,old=None): # check value change of facilities for user train control programing
        if item is None:
            val = auto_read(i)
            save_key = i
        else:
            val = auto_read(i,item)
            save_key = (i,item)
        if save_key in auto_save:
            if auto_save[save_key] != val:
                return_val = 1
            else:
                return_val = 0
            if new is not None:
                if new is not val:
                    return_val = 0
            if old is not None:
                if old is not auto_save[save_key]:
                    return_val = 0
        else:
            return_val = 0
        auto_save[save_key] = val
        return return_val

    def auto_time_start(key):
        auto_time_save[key] = time.perf_counter()

    def auto_time(key):
        if key in auto_time_save:
            return time.perf_counter() - auto_time_save[key]
        else:
            return -1.0

    def auto_time_check(key,t):
        if key in auto_time_save:
            if auto_time(key) >= t:
                auto_time_start(key)
                return 1
            else:
                return 0
        else:
            auto_time_start(key)

    ### end of functions for user train control programing ###
    
#### gui main start ####

    if panel_file_list:
        readfile(panel_file_list)
    else:
        file_name = search_control_file()
        if file_name:
            readfile([file_name])
        else:
            print("### ERROR ### Input file not found (control_panel_1~100.txt)")
            print()
            pygame.quit()
            sys.exit()

    key = K_r

    BACK_PANEL = pygame.display.set_mode((window_w,window_h))
    pygame.display.set_caption("N guage control panel by ik-gadgets")

    colorindex = 0
    firstpoint = []
    draw_back()
    write_bottom_column(key,colorindex)

    tx_end_time = time.perf_counter()

    ### read automatic control program file ###
    auto_prg_str = ""
    if len(auto_prg_file_list):
        for auto_prg_file_name in auto_prg_file_list:
            auto_prg_f = open(auto_prg_file_name,'r',encoding='UTF-8')
            print("user program file = ",auto_prg_file_name)
            auto_prg_str += auto_prg_f.read()
    else:
        print("WARNING: No user program file")

    while True:

    # マウス/キーイベント処理
        for event in pygame.event.get():
            if event.type == QUIT:
                qtx.put([END,END]) # send end flag to BLE_TxRx
                time.sleep(1)
                pygame.quit()
                return
            if event.type == MOUSEMOTION:
                eventflag += 1
                for facility in facilities:
                    facility.select(event.pos)
            if event.type == MOUSEBUTTONDOWN and rx_progress_flag == 0:
                eventflag += 1
                tx_trigger_flag = +1
                key = 0 # to erase string2
                for facility in facilities:
                    facility.mouse(event.button,event.pos)

            # キーイベント処理
            elif event.type == KEYDOWN:
                eventflag += 1
                key = event.key
                if key == K_n:
                    number_ON ^= 1
                if key == K_o:
                    option_ON ^= 1
                elif key == K_w:
                    writefile()
                elif key == K_g:
                    grid_on ^= 1
                elif key == K_r:
                    if panel_file_list:
                        readfile(panel_file_list)
                    else:
                        file_name = search_control_file()
                        if file_name:
                            readfile([file_name])
                        else:
                            print("### ERROR ### Input file not found (control_panel_1~100.txt)")
                elif key == K_h:
                    print_help()

        if auto_prg_str:
            exec(auto_prg_str)

        if eventflag:
            eventflag -= 1
            draw_back()
            for L in lines:
                pygame.draw.line(BACK_PANEL,colorlist[L.color_index],(L.x1,L.y1),(L.x2,L.y2),width=5)
            for facility in facilities:
                facility.draw()
            for t in text_list:
                t.draw()
            write_bottom_column(key,colorindex)
            pygame.display.update()

        #### Tx ####

        diff_time = time.perf_counter() - tx_end_time

        if tx_trigger_flag or (diff_time > txrx_interval):
#            tx_start_time = time.perf_counter()
            if tx_trigger_flag :
                tx_trigger_flag -= 1
                
            for facility in facilities:
                if facility.__class__.__name__ != "Tile":
                    facility.tx(tx_list)
            tx_list.append(END)
            tx_cnt = len(tx_list)
            qtx.put(tx_list)
            tx_list = []
            tx_end_time = time.perf_counter()
            rx_progress_flag = 1

            while qrx.qsize() == 0:
                None
            #### Rx ####
            temp_buf = qrx.get()
            for onebyte in temp_buf:
                oneint = int(onebyte)
                rx_list.append(oneint)
                if oneint == END:
                    rx_progress_flag = 0
                    eventflag += 1
                    for facility in facilities:
                        if facility.__class__.__name__ != "Tile":
                            facility.rx(rx_list)
                    if rx_list:
                        if len(rx_list) == 1 and rx_list[0] == END:
                            rx_list.pop(0)
                        else:
                            print("### ERROR ### Rx error at the end")
                            rx_list = []
                    else:
                        print("### ERROR ### Rx error at the end")
                        rx_list = []

#                txrx_time = time.perf_counter() - tx_start_time
#                print("DEB tr {0:.2f}".format(txrx_time))
